Content-Type: text/plain; charset=iso-8859-1

Changed with 1.0b.1:
  +    XFace support.
  +    Misc. bugfixes based on patches from Matthias Scheler,
       Christian Bauernfeind and Greg Ubben.

Changed with 1.0b.0:
  +    GPL.
  +    Changed the kill-{append|prepend} actions.
  +    New action procedures: kill-{append|prepend}-global().
  +    New action procedure: tree-layout().
  +    Changed handling of domain name slightly.
  +    Misc. bugfixes.

Changed with 0.9.8:
  +    Inline images: support for jpeg, gif and png.  Though
       the dithering performed for grayscale images and gifs
       is very simpleminded.  This has only been tested on
       8 bit displays...
  +    Action procedure forward-by-mail() plus option not to
       use MIME when forwarding.
  +    Configurable forward menu + action proc forward-by-mail().
  +    Resource Knews.quoteEmpty that says whether to quote-prefix
       empty lines.
  +    Cleaned up the menu hierarchy widgets.
  +    Added per-group '[posted and mailed]' warning.
  +    The article text widget handles inline images.  Also made it
       horizontally scrollable, with line wrapping optional.  The
       scrollbar 'textscrbar' was renamed to 'textvbar'.
  +    Some resources to control the scrolling style of the lists.
  +    'Print' on the misc menu...
  +    Removed 'hotish'.  Hot now only affects unread articles.
  +    Hack for iconification of second window: Knews.iconHack.
  +    Support for AUTHINFO SIMPLE (but not for second connection).
  +    New resources confirmCatchup and confirmQuitGroup.

Changed with 0.9.7:
  +    Completely new post popup with attachments and user-defined
       actions for e.g. spell-checking.
  +    MIME decoding of quoted article, when charsets match.
  +    A supersede option on the post-menu.
  +    Decoding of rfc1522 in the thread list and article tree too.
  +    Regexp matching for the find group popup.
  +    New option quoteQuoteString.
  +    Optimization of killing.
  +    Handle needsterminal and copiousoutput.
  +    Horizontal scrolling of lists.
  +    Configurable list width: groupNameColumns and subjectColumns.
  +    followupHeaders: similar to extraHeaders, but expands the
       same %'s as attribution.  E.g. 'X-Comment-To: %r'.
  +    The toggles on the save and search popups are app-def settable.
  +    Proper handling of permissions for .newsrc etc.
  +    Authentication for the second connection.
  +    New action procedures untag-{subject,thread}.
  +    confirmQuit now means verify for disconnect too; also ask for
       verification if there are outstanding posts.
  +    Improved extraction of initials in attribution.
  +    New algorithm for determining domain name.
  +    Show how to set the initial state of the toggles on the save
       and search popup in the app-def file + made the Tab key work
       in the search popup.
  +    Fixed checking for new groups to use the atime of the config
       file, plus a hack for bogus filesystems (e.g. AFS).
  +    New resource Knews.autoSubscribe.
  +    Slight improvement of the saveThreadInfo stuff.
  +    Changed double-clicking in thread list to work for read threads.
  +    New resource Knews.generatePath.
  +    Preserve case when generating references.

Changed with 0.9.6:
  +    Substantially improved handling of the charset parameter
       for the content type text/*, with the ability to specify
       different fonts for different charsets.  This will handle
       any 8 bit charset.
  +    Reworked the article text widget to make it able to display
       wide-character fonts.  Could easily be made to display
       inline images too.
  +    The article tree now has a 'vertical' layout by popular
       demand.  Made it the default too :-)
  +    Decoding of 16 bit encoded charsets (highly experimental),
       support for: utf-7, hz-gb-2312, ksc-5601, big5 ...
  +    Also a defaultCharset config option.
  +    Rfc1522 decoding of headers.
  +    Message/partial assembly.
  +    Support for Content-Transfer-Encoding: [x-]uue[ncode[d]].
  +    More robust base64 decoding.
  +    Added some warnings so the user is notified of garbage
       mime articles (there are lots of them...)
  +    Mailcap file support, removed old viewer resources.
       needsterminal, copiousoutput and test will be ignored...
  +    Reworked the 'thread ahead' to save thread data to temp
       files instead of keeping it in memory.  Also allow these
       files to survive between sessions.
  +    Added article prefetch cache and 'trailing' cache.
  +    Optional caching of group descriptions in a file between sessions.
  +    Simple 'xpm-file to pixmap' converter, for background textures
       using the backgroundPixmap resource.
  +    New kill action 'hotish', like hot but faster in one case.  Further
       optimizations in the future.
  +    An option to have case-sensitive regexps.
  +    Less restrictive locking of the interface: you may scroll
       articles, edit the kill file etc. while knews is busy.
  +    Message-id lookup of articles.
  +    Got rid of the Xmu library, except for editres.
  +    %a for article number in file names.
  +    Various %'s in attribution for date, time etc based on code
       from Mikhail Teterin.
  +    The default uuDir should be News, not ~/News.
  +    Removed AUTHINFO GENERIC.
  +    The searching may now be restricted to threads, or tagged articles,
       and a 'stop' function for search (as opposed to 'abort').
  +    Proper handling of SIGHUP while updating newsrc and kill files.
  +    Support for different visuals and depths(?) + private colormap.

Changed with 0.9.5:
  +    All remotely system dependent code has been stashed away in
       src/sysdeps.c, everything else should be (almost) POSIX.1 + regex.
  +    New config option tryListActive, to make knews try the
       "LIST ACTIVE wildmat" nntp extension when readActiveFile is
       false.  True by default.
  +    Backup newsrc file with link(2), instead of the old, ugly way.
  +    DEFAULT_DEFAULT_NNTPSERVER by request of Piete Brooks.
  +    SIGBUS and a number of errno's not defined #if _POSIX_SOURCE,
       reported by Paul Tomblin and Mark Hannon.
  +    XtEnumerateDatabase doesn't exist in X11R4, reported by
       Chris Siebenmann.
  +    The stderr file descriptor was left blocking when forking.
  +    Extra & in src/resource.c, leading to memory corruption.
       Reported and fixed by Ron Olsen.
  +    Patch to src/thread.c from Dick Streefland: fall back to slow
       threading if XOVER doesn't give all articles, plus one or two bugs.
  +    Some newsreaders backup .newsrc by link(2), which confused
       knews.  Found by Piete Brooks.
  +    The default quoteRegexp was wrong, reported by Henrik Delin.

Changed with 0.9.4:
  +    *** INCOMPATIBILITY WARNING ***
       The per server and per group X resources are gone, instead
       there is a new scheme with a configuration file, which should
       be more flexible and user friendly.  Knews will warn on startup
       if it finds some of the old resource settings.
  +    Sorting of threads.
  +    Fixed clicking on URLs.  Second mouse button in text widget.
  +    A do-the-right-thing() action procedure.
  +    Relization of fake-articles.  (They're still fake, though.)
  +    Fast way to add stuff to the kill file: the append-kill()
       and prepend-kill() action procedures, by default bound to
       the keys Ctrl-[kK] for thread/subthread kills and [Shift] F1...F4
       for red, green, blue and yellow [thread] subthread hot entries.
  +    Spiffed up the 3D effect for the widgets on monochrome displays.
       The old interface can be had by setting '*useLineShadows: True'.
  +    Fixed race conditions in the scroll bar and the article tree
       scrolling: the tree scrolling should be smoother now.
  +    Also a more serious race condition in the 'pane resizing'.
  +    Made the subject reflect the followup status of the 'next' article,
       and removed the fixedAuthor resource.
  +    Kill entries in the kill file now do not affect 'hot' articles.
       Note that the entries are executed in sequence, so you can put
       'hard' kills at the beginning and 'soft' kills at the end.
  +    Made 'Previous' mark the current article unread.
  +    list-up() and list-down() now accepts relative values.
  +    Stripped down knewsd to its bare bones, and made it able to accept
       posts by piping them to e.g. "inews -h".
  +    Optional confirmation for quit: the Knews.confirmQuit resource.
  +    New misc: mark-read-untagged and mark-read-cold.
  +    Added a hot-counter to the status-line.
  +    An "ask how many" feature.
  +    New command line option +/-keep.
  +    Made knews fetch the Xref header on the fly while reading an
       article if the Xref header was is not in the overview files.
  +    Moved the layouts out from the app-def file.
  +    Fixed a bug that made the editor "hang" sometimes.
  +    Fixed a bug that made knews hang at 96% of threading occasionally,
       with assistance by Joao Cardoso.
  +    Suggestions and code from Matthias Schuetze: icon, %r in attribution
       for real name, distributions, %i in quoteString for initials.
  +    Improvement of 'pre-post' message, including listing of the groups
       the article is being posted to, based on code by Jörg Wunsch.
  +    Fixed posting to handle lines with leading dots properly.
  +    Don't close stdout by request of Mark Crimmins.

Changes with 0.9.3:
  +    XPAT searching.
  +    Thread ahead: advance threading of groups in the background and an
       action procedure schedule-thread-ahead().  The default translation
       for this is the third mouse button in the group list.
  +    New resources 'keepThreadInfo' and 'threadEmAll'.
  +    Only check subscribed groups when readActiveFile is False.
  +    A 'Find group' popup in the 'subscribed groups' and 'all groups` mode
       with tab completion, and an action procedure: popup-find-group().
  +    New option on the misc menu: 'mark read to current' and corresponding
       action procedure mark-read-to-current().
  +    Changed the forward option a bit.
  +    Added a history mechanism and replaced the 'next breadth' button with
       a 'previous' button.
  +    New resource 'mailName' for people with non-standard addresses.
  +    Made the author name in the thread list change with the 'next' article,
       plus a resource 'fixedAuthor' if you dislike this.
  +    Changed the 'All threads' button to a toggle.
  +    The default fonts have been changed to a more sane size.
  +    A 'uuProgram' resource to allow the user to use his/her own uudecoder.
  +    Improved the algorithm for finding uuencoded parts a bit.
  +    An extensible but obscure mechanism for using an arbitrary program as
       an nntp server via fork+exec.  This can be used to read the spool dir
       and even mail folders.
  +    A couple of bugs pointed out by Andrew R Tefft, Scott Stevens and
       Robert Campbell.

Changes with 0.9.2:
  +    The main window is now supposed to size itself according to the
       fonts.  Remove your geometry settings, and use the preferredLines
       and preferredColumns resources in the appdef file instead.
  +    New resource Knews.separateWindows to make knews use a separate top
       level window for the article text window.
  +    Rudimentary internal MIME viewer: 'Save to file or pipe to shell'.
       The only MIME types now shown raw are text/* and message/* (not rfc822).
  +    Asynchronous reporting of the exit status of MIME viewers.
  +    Pipe now means save to temporary file + fork & exec with asynchronous
       reporting of exit status.
  +    Improved reconnecting to server, with reissue of nntp command.
  +    A couple of bugs pointed out by Andrew R. Tefft.
  +    Installed Xlib error handler and X I/O error handler, so that X protocol
       errors are not fatal, and KillClients are handled gracefully.
  +    Fixed a bug that let the user pull hot pixmaps out from under
       knews.  Reported by Nathan J. Mehl.
  +    New action procedures pipe(), save(), tag-thread() and tag-subject(),
       catchup(), subscribe(), unsubscribe(), change-size().
  +    Subjects with tagged articles are marked with an asterisk in the list.
  +    Save/pipe understands ~ for $HOME and %n/%N/%g/%G for capitalized and/or
       slashed newsgroup name.  Directories that don't exist will be created.
  +    Forward option on the post menu.
  +    Support for raw IP address in $NNTPSERVER.
  +    Removed 4 line limit on sigs.
  +    File completion for the FileSelWidget.
  +    Optionally show number of lines of articles in thread tree.
  +    It's now possible to subscribe/unsubscribe inside a group and
       subscribe/catchup in the 'subscribed groups' list.
  +    The default editCommand now is  xterm -e vi +%i %s
  +    No limit on line length in newsrc files.
  +    Optionally don't read the active file when connecting based on
       some diffs from Jan Andersson.
  +    Option to write all groups knews knows about to the newsrc file.
  +    Allow the user to specify a postingAgent used to post articles.
       You could set this to 'inews -h', if you want.

Changes with 0.9.1:
  +    Will now get HEAD from the server if it doesn't support XOVER.
       This is very slow.
  +    Next depth/breadth now takes you out of the group if there are
       no more unread articles.
  +    The gecos field of the passwd file is chopped of at the first ','.
  +    Internal support for MIME content types text/plain, message/rfc822,
       multipart/mixed and multipart/digest.
  +    Ability to specify external viewers for any type/subtypes, with
       extra resource subhierarchies for text/* and message/external-body.
  +    'Full header' now means turn off all MIME stuff.
  +    Support for quoted-printable and base64 encodings.
  +    Regexp searching of article text/body/subject/from and in the
       group list.
  +    Lots of action procedures, and a few default keyboard translations.
  +    Drag-and-drop in the group list and the kill list to reorder the
       .newsrc file and the kill file.
  +    AUTHINFO GENERIC. I haven't been able to test this.
  +    Lots of internal clean-up, including the save/pipe function, forking
       of editors.  Will use poll(2) instead of select(2) is SYSV is defined.
  +    Removed 'reopen'.
  +    Cleaned up and fixed a bug in the Layout Widget, thanks to leo@marco.de.
  +    Some provisions to be able to compile with R4. I'm not sure if it works.
  +    When posting a new article, %i means start at the subject line.
  +    Fixed a bug in save subject reported by Rainer Krienke.
